/* sound-player.c generated by valac 0.56.3, the Vala compiler
 * generated from sound-player.vala, do not modify */

/*
 * Copyright 2020 Andrey Kutejko <andy128k@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 * For more details see the file COPYING.
 */

#include <glib-object.h>
#include <gsound.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	SOUND_VICTORY = 0,
	SOUND_DIE,
	SOUND_TELEPORT,
	SOUND_SPLAT,
	SOUND_YAHOO,
	SOUND_BAD
} Sound;

#define TYPE_SOUND (sound_get_type ())

#define TYPE_SOUND_PLAYER (sound_player_get_type ())
#define SOUND_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOUND_PLAYER, SoundPlayer))
#define SOUND_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOUND_PLAYER, SoundPlayerClass))
#define IS_SOUND_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOUND_PLAYER))
#define IS_SOUND_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOUND_PLAYER))
#define SOUND_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOUND_PLAYER, SoundPlayerClass))

typedef struct _SoundPlayer SoundPlayer;
typedef struct _SoundPlayerClass SoundPlayerClass;
typedef struct _SoundPlayerPrivate SoundPlayerPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecSoundPlayer ParamSpecSoundPlayer;

struct _SoundPlayer {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SoundPlayerPrivate * priv;
};

struct _SoundPlayerClass {
	GTypeClass parent_class;
	void (*finalize) (SoundPlayer *self);
};

struct _SoundPlayerPrivate {
	GSoundContext* ctx;
};

struct _ParamSpecSoundPlayer {
	GParamSpec parent_instance;
};

static gint SoundPlayer_private_offset;
static gpointer sound_player_parent_class = NULL;

VALA_EXTERN GType sound_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gpointer sound_player_ref (gpointer instance);
VALA_EXTERN void sound_player_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_sound_player (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags);
VALA_EXTERN void value_set_sound_player (GValue* value,
                             gpointer v_object);
VALA_EXTERN void value_take_sound_player (GValue* value,
                              gpointer v_object);
VALA_EXTERN gpointer value_get_sound_player (const GValue* value);
VALA_EXTERN GType sound_player_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SoundPlayer, sound_player_unref)
VALA_EXTERN SoundPlayer* sound_player_new (void);
VALA_EXTERN SoundPlayer* sound_player_construct (GType object_type);
VALA_EXTERN void sound_player_beep (SoundPlayer* self);
VALA_EXTERN void sound_player_play_file (SoundPlayer* self,
                             const gchar* name);
VALA_EXTERN void sound_player_play (SoundPlayer* self,
                        Sound sound);
static void sound_player_finalize (SoundPlayer * obj);
static GType sound_player_get_type_once (void);

static GType
sound_get_type_once (void)
{
	static const GEnumValue values[] = {{SOUND_VICTORY, "SOUND_VICTORY", "victory"}, {SOUND_DIE, "SOUND_DIE", "die"}, {SOUND_TELEPORT, "SOUND_TELEPORT", "teleport"}, {SOUND_SPLAT, "SOUND_SPLAT", "splat"}, {SOUND_YAHOO, "SOUND_YAHOO", "yahoo"}, {SOUND_BAD, "SOUND_BAD", "bad"}, {0, NULL, NULL}};
	GType sound_type_id;
	sound_type_id = g_enum_register_static ("Sound", values);
	return sound_type_id;
}

GType
sound_get_type (void)
{
	static volatile gsize sound_type_id__once = 0;
	if (g_once_init_enter (&sound_type_id__once)) {
		GType sound_type_id;
		sound_type_id = sound_get_type_once ();
		g_once_init_leave (&sound_type_id__once, sound_type_id);
	}
	return sound_type_id__once;
}

static inline gpointer
sound_player_get_instance_private (SoundPlayer* self)
{
	return G_STRUCT_MEMBER_P (self, SoundPlayer_private_offset);
}

SoundPlayer*
sound_player_construct (GType object_type)
{
	SoundPlayer* self = NULL;
	GError* _inner_error0_ = NULL;
#line 33 "../src/sound-player.vala"
	self = (SoundPlayer*) g_type_create_instance (object_type);
#line 149 "sound-player.c"
	{
		GSoundContext* _tmp0_ = NULL;
		GSoundContext* _tmp1_;
		GSoundContext* _tmp2_;
#line 35 "../src/sound-player.vala"
		_tmp1_ = gsound_context_new (NULL, &_inner_error0_);
#line 35 "../src/sound-player.vala"
		_tmp0_ = _tmp1_;
#line 35 "../src/sound-player.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 160 "sound-player.c"
			goto __catch0_g_error;
		}
#line 35 "../src/sound-player.vala"
		_tmp2_ = _tmp0_;
#line 35 "../src/sound-player.vala"
		_tmp0_ = NULL;
#line 35 "../src/sound-player.vala"
		_g_object_unref0 (self->priv->ctx);
#line 35 "../src/sound-player.vala"
		self->priv->ctx = _tmp2_;
#line 34 "../src/sound-player.vala"
		_g_object_unref0 (_tmp0_);
#line 173 "sound-player.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 34 "../src/sound-player.vala"
		_error_ = _inner_error0_;
#line 34 "../src/sound-player.vala"
		_inner_error0_ = NULL;
#line 37 "../src/sound-player.vala"
		_tmp3_ = _error_;
#line 37 "../src/sound-player.vala"
		_tmp4_ = _tmp3_->message;
#line 37 "../src/sound-player.vala"
		g_warning ("sound-player.vala:37: Failed to create gsound context: %s", _tmp4_);
#line 38 "../src/sound-player.vala"
		_g_object_unref0 (self->priv->ctx);
#line 38 "../src/sound-player.vala"
		self->priv->ctx = NULL;
#line 34 "../src/sound-player.vala"
		_g_error_free0 (_error_);
#line 197 "sound-player.c"
	}
	__finally0:
#line 34 "../src/sound-player.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 34 "../src/sound-player.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 34 "../src/sound-player.vala"
		g_clear_error (&_inner_error0_);
#line 34 "../src/sound-player.vala"
		return NULL;
#line 208 "sound-player.c"
	}
#line 33 "../src/sound-player.vala"
	return self;
#line 212 "sound-player.c"
}

SoundPlayer*
sound_player_new (void)
{
#line 33 "../src/sound-player.vala"
	return sound_player_construct (TYPE_SOUND_PLAYER);
#line 220 "sound-player.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 43 "../src/sound-player.vala"
	return self ? g_object_ref (self) : NULL;
#line 228 "sound-player.c"
}

void
sound_player_beep (SoundPlayer* self)
{
	GdkDisplay* display = NULL;
	GdkDisplay* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkDisplay* _tmp2_;
#line 42 "../src/sound-player.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/sound-player.vala"
	_tmp0_ = gdk_display_get_default ();
#line 43 "../src/sound-player.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 43 "../src/sound-player.vala"
	display = _tmp1_;
#line 44 "../src/sound-player.vala"
	_tmp2_ = display;
#line 44 "../src/sound-player.vala"
	if (_tmp2_ != NULL) {
#line 250 "sound-player.c"
		GdkDisplay* _tmp3_;
#line 45 "../src/sound-player.vala"
		_tmp3_ = display;
#line 45 "../src/sound-player.vala"
		gdk_display_beep (_tmp3_);
#line 256 "sound-player.c"
	}
#line 42 "../src/sound-player.vala"
	_g_object_unref0 (display);
#line 260 "sound-player.c"
}

void
sound_player_play_file (SoundPlayer* self,
                        const gchar* name)
{
	GSoundContext* _tmp0_;
	gchar* filename = NULL;
	gchar* _tmp1_;
	gchar* path = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 49 "../src/sound-player.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/sound-player.vala"
	g_return_if_fail (name != NULL);
#line 50 "../src/sound-player.vala"
	_tmp0_ = self->priv->ctx;
#line 50 "../src/sound-player.vala"
	if (_tmp0_ == NULL) {
#line 51 "../src/sound-player.vala"
		return;
#line 284 "sound-player.c"
	}
#line 54 "../src/sound-player.vala"
	_tmp1_ = g_strdup_printf ("%s.ogg", name);
#line 54 "../src/sound-player.vala"
	filename = _tmp1_;
#line 55 "../src/sound-player.vala"
	_tmp2_ = filename;
#line 55 "../src/sound-player.vala"
	_tmp3_ = g_build_filename (SOUND_DIRECTORY, _tmp2_, NULL);
#line 55 "../src/sound-player.vala"
	path = _tmp3_;
#line 296 "sound-player.c"
	{
		GSoundContext* _tmp4_;
		const gchar* _tmp5_;
#line 58 "../src/sound-player.vala"
		_tmp4_ = self->priv->ctx;
#line 58 "../src/sound-player.vala"
		_tmp5_ = path;
#line 58 "../src/sound-player.vala"
		gsound_context_play_simple (_tmp4_, NULL, &_inner_error0_, GSOUND_ATTR_MEDIA_NAME, name, GSOUND_ATTR_MEDIA_FILENAME, _tmp5_, NULL);
#line 58 "../src/sound-player.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 308 "sound-player.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 57 "../src/sound-player.vala"
		_error_ = _inner_error0_;
#line 57 "../src/sound-player.vala"
		_inner_error0_ = NULL;
#line 62 "../src/sound-player.vala"
		_tmp6_ = _error_;
#line 62 "../src/sound-player.vala"
		_tmp7_ = _tmp6_->message;
#line 62 "../src/sound-player.vala"
		g_warning ("sound-player.vala:62: Failed to play sound \"%s\": %s", name, _tmp7_);
#line 57 "../src/sound-player.vala"
		_g_error_free0 (_error_);
#line 330 "sound-player.c"
	}
	__finally0:
#line 57 "../src/sound-player.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 57 "../src/sound-player.vala"
		_g_free0 (path);
#line 57 "../src/sound-player.vala"
		_g_free0 (filename);
#line 57 "../src/sound-player.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 57 "../src/sound-player.vala"
		g_clear_error (&_inner_error0_);
#line 57 "../src/sound-player.vala"
		return;
#line 345 "sound-player.c"
	}
#line 49 "../src/sound-player.vala"
	_g_free0 (path);
#line 49 "../src/sound-player.vala"
	_g_free0 (filename);
#line 351 "sound-player.c"
}

void
sound_player_play (SoundPlayer* self,
                   Sound sound)
{
#line 66 "../src/sound-player.vala"
	g_return_if_fail (self != NULL);
#line 67 "../src/sound-player.vala"
	switch (sound) {
#line 67 "../src/sound-player.vala"
		case SOUND_VICTORY:
#line 364 "sound-player.c"
		{
#line 69 "../src/sound-player.vala"
			sound_player_play_file (self, "victory");
#line 70 "../src/sound-player.vala"
			break;
#line 370 "sound-player.c"
		}
#line 67 "../src/sound-player.vala"
		case SOUND_DIE:
#line 374 "sound-player.c"
		{
#line 72 "../src/sound-player.vala"
			sound_player_play_file (self, "die");
#line 73 "../src/sound-player.vala"
			break;
#line 380 "sound-player.c"
		}
#line 67 "../src/sound-player.vala"
		case SOUND_TELEPORT:
#line 384 "sound-player.c"
		{
#line 75 "../src/sound-player.vala"
			sound_player_play_file (self, "teleport");
#line 76 "../src/sound-player.vala"
			break;
#line 390 "sound-player.c"
		}
#line 67 "../src/sound-player.vala"
		case SOUND_SPLAT:
#line 394 "sound-player.c"
		{
#line 78 "../src/sound-player.vala"
			sound_player_play_file (self, "splat");
#line 79 "../src/sound-player.vala"
			break;
#line 400 "sound-player.c"
		}
#line 67 "../src/sound-player.vala"
		case SOUND_YAHOO:
#line 404 "sound-player.c"
		{
#line 81 "../src/sound-player.vala"
			sound_player_play_file (self, "yahoo");
#line 82 "../src/sound-player.vala"
			break;
#line 410 "sound-player.c"
		}
#line 67 "../src/sound-player.vala"
		case SOUND_BAD:
#line 414 "sound-player.c"
		{
#line 84 "../src/sound-player.vala"
			sound_player_beep (self);
#line 85 "../src/sound-player.vala"
			break;
#line 420 "sound-player.c"
		}
		default:
#line 67 "../src/sound-player.vala"
		break;
#line 425 "sound-player.c"
	}
}

static void
value_sound_player_init (GValue* value)
{
#line 29 "../src/sound-player.vala"
	value->data[0].v_pointer = NULL;
#line 434 "sound-player.c"
}

static void
value_sound_player_free_value (GValue* value)
{
#line 29 "../src/sound-player.vala"
	if (value->data[0].v_pointer) {
#line 29 "../src/sound-player.vala"
		sound_player_unref (value->data[0].v_pointer);
#line 444 "sound-player.c"
	}
}

static void
value_sound_player_copy_value (const GValue* src_value,
                               GValue* dest_value)
{
#line 29 "../src/sound-player.vala"
	if (src_value->data[0].v_pointer) {
#line 29 "../src/sound-player.vala"
		dest_value->data[0].v_pointer = sound_player_ref (src_value->data[0].v_pointer);
#line 456 "sound-player.c"
	} else {
#line 29 "../src/sound-player.vala"
		dest_value->data[0].v_pointer = NULL;
#line 460 "sound-player.c"
	}
}

static gpointer
value_sound_player_peek_pointer (const GValue* value)
{
#line 29 "../src/sound-player.vala"
	return value->data[0].v_pointer;
#line 469 "sound-player.c"
}

static gchar*
value_sound_player_collect_value (GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
#line 29 "../src/sound-player.vala"
	if (collect_values[0].v_pointer) {
#line 480 "sound-player.c"
		SoundPlayer * object;
		object = collect_values[0].v_pointer;
#line 29 "../src/sound-player.vala"
		if (object->parent_instance.g_class == NULL) {
#line 29 "../src/sound-player.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 487 "sound-player.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 29 "../src/sound-player.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 491 "sound-player.c"
		}
#line 29 "../src/sound-player.vala"
		value->data[0].v_pointer = sound_player_ref (object);
#line 495 "sound-player.c"
	} else {
#line 29 "../src/sound-player.vala"
		value->data[0].v_pointer = NULL;
#line 499 "sound-player.c"
	}
#line 29 "../src/sound-player.vala"
	return NULL;
#line 503 "sound-player.c"
}

static gchar*
value_sound_player_lcopy_value (const GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	SoundPlayer ** object_p;
	object_p = collect_values[0].v_pointer;
#line 29 "../src/sound-player.vala"
	if (!object_p) {
#line 29 "../src/sound-player.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 518 "sound-player.c"
	}
#line 29 "../src/sound-player.vala"
	if (!value->data[0].v_pointer) {
#line 29 "../src/sound-player.vala"
		*object_p = NULL;
#line 524 "sound-player.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 29 "../src/sound-player.vala"
		*object_p = value->data[0].v_pointer;
#line 528 "sound-player.c"
	} else {
#line 29 "../src/sound-player.vala"
		*object_p = sound_player_ref (value->data[0].v_pointer);
#line 532 "sound-player.c"
	}
#line 29 "../src/sound-player.vala"
	return NULL;
#line 536 "sound-player.c"
}

GParamSpec*
param_spec_sound_player (const gchar* name,
                         const gchar* nick,
                         const gchar* blurb,
                         GType object_type,
                         GParamFlags flags)
{
	ParamSpecSoundPlayer* spec;
#line 29 "../src/sound-player.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SOUND_PLAYER), NULL);
#line 29 "../src/sound-player.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 29 "../src/sound-player.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 29 "../src/sound-player.vala"
	return G_PARAM_SPEC (spec);
#line 555 "sound-player.c"
}

gpointer
value_get_sound_player (const GValue* value)
{
#line 29 "../src/sound-player.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOUND_PLAYER), NULL);
#line 29 "../src/sound-player.vala"
	return value->data[0].v_pointer;
#line 565 "sound-player.c"
}

void
value_set_sound_player (GValue* value,
                        gpointer v_object)
{
	SoundPlayer * old;
#line 29 "../src/sound-player.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOUND_PLAYER));
#line 29 "../src/sound-player.vala"
	old = value->data[0].v_pointer;
#line 29 "../src/sound-player.vala"
	if (v_object) {
#line 29 "../src/sound-player.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOUND_PLAYER));
#line 29 "../src/sound-player.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 29 "../src/sound-player.vala"
		value->data[0].v_pointer = v_object;
#line 29 "../src/sound-player.vala"
		sound_player_ref (value->data[0].v_pointer);
#line 587 "sound-player.c"
	} else {
#line 29 "../src/sound-player.vala"
		value->data[0].v_pointer = NULL;
#line 591 "sound-player.c"
	}
#line 29 "../src/sound-player.vala"
	if (old) {
#line 29 "../src/sound-player.vala"
		sound_player_unref (old);
#line 597 "sound-player.c"
	}
}

void
value_take_sound_player (GValue* value,
                         gpointer v_object)
{
	SoundPlayer * old;
#line 29 "../src/sound-player.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOUND_PLAYER));
#line 29 "../src/sound-player.vala"
	old = value->data[0].v_pointer;
#line 29 "../src/sound-player.vala"
	if (v_object) {
#line 29 "../src/sound-player.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOUND_PLAYER));
#line 29 "../src/sound-player.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 29 "../src/sound-player.vala"
		value->data[0].v_pointer = v_object;
#line 618 "sound-player.c"
	} else {
#line 29 "../src/sound-player.vala"
		value->data[0].v_pointer = NULL;
#line 622 "sound-player.c"
	}
#line 29 "../src/sound-player.vala"
	if (old) {
#line 29 "../src/sound-player.vala"
		sound_player_unref (old);
#line 628 "sound-player.c"
	}
}

static void
sound_player_class_init (SoundPlayerClass * klass,
                         gpointer klass_data)
{
#line 29 "../src/sound-player.vala"
	sound_player_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/sound-player.vala"
	((SoundPlayerClass *) klass)->finalize = sound_player_finalize;
#line 29 "../src/sound-player.vala"
	g_type_class_adjust_private_offset (klass, &SoundPlayer_private_offset);
#line 642 "sound-player.c"
}

static void
sound_player_instance_init (SoundPlayer * self,
                            gpointer klass)
{
#line 29 "../src/sound-player.vala"
	self->priv = sound_player_get_instance_private (self);
#line 29 "../src/sound-player.vala"
	self->ref_count = 1;
#line 653 "sound-player.c"
}

static void
sound_player_finalize (SoundPlayer * obj)
{
	SoundPlayer * self;
#line 29 "../src/sound-player.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SOUND_PLAYER, SoundPlayer);
#line 29 "../src/sound-player.vala"
	g_signal_handlers_destroy (self);
#line 31 "../src/sound-player.vala"
	_g_object_unref0 (self->priv->ctx);
#line 666 "sound-player.c"
}

static GType
sound_player_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_sound_player_init, value_sound_player_free_value, value_sound_player_copy_value, value_sound_player_peek_pointer, "p", value_sound_player_collect_value, "p", value_sound_player_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (SoundPlayerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_player_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundPlayer), 0, (GInstanceInitFunc) sound_player_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType sound_player_type_id;
	sound_player_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SoundPlayer", &g_define_type_info, &g_define_type_fundamental_info, 0);
	SoundPlayer_private_offset = g_type_add_instance_private (sound_player_type_id, sizeof (SoundPlayerPrivate));
	return sound_player_type_id;
}

GType
sound_player_get_type (void)
{
	static volatile gsize sound_player_type_id__once = 0;
	if (g_once_init_enter (&sound_player_type_id__once)) {
		GType sound_player_type_id;
		sound_player_type_id = sound_player_get_type_once ();
		g_once_init_leave (&sound_player_type_id__once, sound_player_type_id);
	}
	return sound_player_type_id__once;
}

gpointer
sound_player_ref (gpointer instance)
{
	SoundPlayer * self;
	self = instance;
#line 29 "../src/sound-player.vala"
	g_atomic_int_inc (&self->ref_count);
#line 29 "../src/sound-player.vala"
	return instance;
#line 702 "sound-player.c"
}

void
sound_player_unref (gpointer instance)
{
	SoundPlayer * self;
	self = instance;
#line 29 "../src/sound-player.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 29 "../src/sound-player.vala"
		SOUND_PLAYER_GET_CLASS (self)->finalize (self);
#line 29 "../src/sound-player.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 716 "sound-player.c"
	}
}

